/*
** Filename: UART2USBSlaveHIDKbd.c
**
** Automatically created by Application Wizard 1.4.2
**
** Part of solution UART2USBSlaveHIDKbd in project UART2USBSlaveHIDKbd
**
** Comments:
**
** Important: Sections between markers "FTDI:S*" and "FTDI:E*" will be overwritten by
** the Application Wizard
*/

#include "SPISlave2USBSlaveHIDKbd.h"
#include "USBSlaveHIDKbdDrv.h"

#define KEY_COUNT 70
#define NAN_KEY_COUNT 23

unsigned char ASCII_Keyboard[KEY_COUNT][3] = {
	{KEY_A, 'a', 'A'},
	{KEY_B, 'b', 'B'},
	{KEY_C, 'c', 'C'},
	{KEY_D, 'd', 'D'},
	{KEY_E, 'e', 'E'},
	{KEY_F, 'f', 'F'},
	{KEY_G, 'g', 'G'},
	{KEY_H, 'h', 'H'},
	{KEY_I, 'i', 'I'},
	{KEY_J, 'j', 'J'},
	{KEY_K, 'k', 'K'},
	{KEY_L, 'l', 'L'},
	{KEY_M, 'm', 'M'},
	{KEY_N, 'n', 'N'},
	{KEY_O, 'o', 'O'},
	{KEY_P, 'p', 'P'},
	{KEY_Q, 'q', 'Q'},
	{KEY_R, 'r', 'R'},
	{KEY_S, 's', 'S'},
	{KEY_T, 't', 'T'},
	{KEY_U, 'u', 'U'},
	{KEY_V, 'v', 'V'},
	{KEY_W, 'w', 'W'},
	{KEY_X, 'x', 'X'},
	{KEY_Y, 'y', 'Y'},
	{KEY_Z, 'z', 'Z'},
	{KEY_1, '1', '!'},
	{KEY_2, '2', '"'},
	{KEY_3, '3', ''},
	{KEY_4, '4', '$'},
	{KEY_5, '5', '%'},
	{KEY_6, '6', '^'},
	{KEY_7, '7', '&'},
	{KEY_8, '8', '*'},
	{KEY_9, '9', '('},
	{KEY_0, '0', ')'},
	{KEY_ENTER, 0x0D, 0},
	{KEY_ESC, 0x1B, 0},
	{KEY_BACKSPACE, 0x08, 0},
	{KEY_TAB, 0x09, 0},
	{KEY_SPACE, ' ', 0},
	{KEY_MINUS, '-', '_'},
	{KEY_EQUAL, '=', '+'},
	{KEY_BACKSLASH, '\\', '|'},
	{KEY_SEMICOLON, ';', 0},
	{KEY_QUOTE, '\'', '@'},
	{KEY_COMMA, ',', '<'},
	{KEY_PERIOD, '.', '>'},
	{KEY_SLASH, '/', '?'},
	{KEY_LEFT_BRACE, '[', '{'},
	{KEY_RIGHT_BRACE, ']', '}'},
	{KEY_NUMBER, '#', '~'},
	{KEY_SEMICOLON,';', ':'},
};

unsigned char NonASCII[NAN_KEY_COUNT][2] = {
	{KEY_RIGHT, 0x4D},
	{KEY_LEFT, 0x4B},
	{KEY_DOWN, 0x50},
	{KEY_UP, 0x48},
	{KEY_CAPS_LOCK, 0x3A},
	{KEY_F1, 0x3B},
	{KEY_F2, 0x3C},
	{KEY_F3, 0x3D},
	{KEY_F4, 0x3E},
	{KEY_F5, 0x3F},
	{KEY_F6, 0x40},
	{KEY_F7, 0x41},
	{KEY_F8, 0x42},
	{KEY_F9, 0x43},
	{KEY_F10, 0x44},
	{KEY_F11, 0x57},
	{KEY_F12, 0x58},
	{KEY_DELETE, 0x53},
	{KEY_INSERT, 0x52},
	{KEY_HOME, 0x47},
	{KEY_PAGE_UP, 0x49},
	{KEY_PAGE_DOWN, 0x51},
	{KEY_END, 0x4F},
};

/* FTDI:STP Thread Prototypes */
vos_tcb_t *tcbSETUP;
vos_tcb_t *tcbSPI;

void setup();
void spi();
/* FTDI:ETP */
unsigned char ASCIItoKey(unsigned char ascii, unsigned char *key, unsigned char *modifier);
unsigned char NonAlphaNumeric();

/* FTDI:SDH Driver Handles */
VOS_HANDLE hUSBSLAVE_1; // USB Slave Port 1
VOS_HANDLE hSPI_SLAVE_1; // SPISlave Port 1 Interface Driver
/* FTDI:EDH */
VOS_HANDLE hUSBSLAVEKEYBRD; // USB Slave Keyboard Driver

vos_semaphore_t setupSem;

/* Declaration for IOMUx setup function */
void iomux_setup(void);

/* Main code - entry point to firmware */
void main(void)
{
	/* FTDI:SDD Driver Declarations */
	// SPI Slave 0 configuration context
	spislave_context_t spisContext0;
	/* FTDI:EDD */

	/* FTDI:SKI Kernel Initialisation */
	vos_init(50, VOS_TICK_INTERVAL, VOS_NUMBER_DEVICES);
	vos_set_clock_frequency(VOS_48MHZ_CLOCK_FREQUENCY);
	vos_set_idle_thread_tcb_size(512);
	/* FTDI:EKI */

	iomux_setup();

	/* FTDI:SDI Driver Initialisation */
	// Initialise USB Slave Port 0
	usbslave_init(0, VOS_DEV_USBSLAVE_1);
	// Initialise SPI Slave 0
	spisContext0.buffer_size = VOS_BUFFER_SIZE_128_BYTES;
	spislave_init(VOS_DEV_SPI_SLAVE_1,&spisContext0);
	/* FTDI:EDI */

	usbslavehidkbd_init(VOS_DEV_USBSLAVEHIDKBD);

	/* FTDI:SCT Thread Creation */
	tcbSETUP = vos_create_thread_ex(22, 4096, setup, "Setup", 0);
	tcbSPI = vos_create_thread_ex(21, 4096, spi, "SPISlave", 0);
	/* FTDI:ECT */

	vos_init_semaphore(&setupSem, 0);

	vos_start_scheduler();

main_loop:
	goto main_loop;
}

/* FTDI:SSP Support Functions */
/* FTDI:ESP */

void open_drivers(void)
{
    /* Code for opening and closing drivers - move to required places in Application Threads */
    /* FTDI:SDA Driver Open */
    hUSBSLAVE_1 = vos_dev_open(VOS_DEV_USBSLAVE_1);
    hSPI_SLAVE_1 = vos_dev_open(VOS_DEV_SPI_SLAVE_1);
    /* FTDI:EDA */
	hUSBSLAVEKEYBRD = vos_dev_open(VOS_DEV_USBSLAVEHIDKBD);
}

void attach_drivers(void)
{
	common_ioctl_cb_t hidAttach;

	/* FTDI:SUA Layered Driver Attach Function Calls */
	/* FTDI:EUA */

	// attach HID Keyboard to USB Slave port A
	hidAttach.ioctl_code = VOS_IOCTL_USBSLAVEHID_ATTACH;
	hidAttach.set.data = (void *)hUSBSLAVE_1;
	vos_dev_ioctl(hUSBSLAVEKEYBRD, &hidAttach);
}

void close_drivers(void)
{
    /* FTDI:SDB Driver Close */
    vos_dev_close(hUSBSLAVE_1);
    vos_dev_close(hSPI_SLAVE_1);
    /* FTDI:EDB */

	vos_dev_close(hUSBSLAVEKEYBRD);
}

/* Application Threads */

void setup()
{
	common_ioctl_cb_t spis_iocb;

	open_drivers();
	attach_drivers();

	// Setup SPI
	spis_iocb.ioctl_code = VOS_IOCTL_SPI_SLAVE_DATA_ORDER;
	spis_iocb.set.param = SPI_SLAVE_DATA_ORDER_MSB;
	vos_dev_ioctl(hSPI_SLAVE_1, &spis_iocb);
	// set SPI mode
	spis_iocb.ioctl_code = VOS_IOCTL_SPI_SLAVE_SET_MODE;
	spis_iocb.set.param = SPI_SLAVE_MODE_VI_COMPATIBLE;
	vos_dev_ioctl(hSPI_SLAVE_1,&spis_iocb);
	// set clock polarity
	spis_iocb.ioctl_code = VOS_IOCTL_SPI_SLAVE_SCK_CPOL;
	spis_iocb.set.param = SPI_SLAVE_SCK_CPOL_0;
	vos_dev_ioctl(hSPI_SLAVE_1,&spis_iocb);
	// set clock phase
	spis_iocb.ioctl_code = VOS_IOCTL_SPI_SLAVE_SCK_CPHA;
	spis_iocb.set.param = SPI_SLAVE_SCK_CPHA_0;
	vos_dev_ioctl(hSPI_SLAVE_1,&spis_iocb);

	vos_signal_semaphore(&setupSem);
}

void spi()
{
	common_ioctl_cb_t uart_iocb;
	unsigned short dataAvail = 0;
	unsigned char report_buffer[8];
	unsigned short num_xfer;

	vos_wait_semaphore(&setupSem);
	vos_memset(report_buffer, 0, 8);

	while (1)
	{
		// get bytes available...
		uart_iocb.ioctl_code = VOS_IOCTL_COMMON_GET_RX_QUEUE_STATUS;
		vos_dev_ioctl(hSPI_SLAVE_1, &uart_iocb);
		dataAvail = uart_iocb.get.queue_stat; // How much data to read?

		if (dataAvail)
		{
			unsigned char ascii, key, modifier = 0;

			vos_dev_read(hSPI_SLAVE_1, &ascii, 1, &num_xfer);
			if (ASCIItoKey(ascii, &key, &modifier))
			{
				report_buffer[0] = modifier;
				report_buffer[2] = key;
				// Write key down...
				vos_dev_write(hUSBSLAVEKEYBRD, report_buffer, 8, &num_xfer);
				report_buffer[0] = 0x00;
				report_buffer[2] = key + 0x80;
				// Write key up...
				vos_dev_write(hUSBSLAVEKEYBRD, report_buffer, 8, &num_xfer);
				key = 0x00;
			}
		}
	}
}

unsigned char ASCIItoKey(unsigned char ascii, unsigned char *key, unsigned char *modifier)
{
	int i = 0;
	*key = 0;
	*modifier = 0;

	if (ascii == 0x00)
		return 0;

	if (ascii == 0xE0)
		return NonAlphaNumeric();

	// Firstly, search the non shifted characters...
	for (i = 0; i < KEY_COUNT; i++)
	{
		unsigned char test = ASCII_Keyboard[i][1];
		if (ASCII_Keyboard[i][1] == ascii)
		{
			*key = ASCII_Keyboard[i][0];
			return 1;
		}
	}
	// Search the shifted characters...
	for (i = 0; i < KEY_COUNT; i++)
	{
		if (ASCII_Keyboard[i][2] == ascii)
		{
			*key = ASCII_Keyboard[i][0];
			*modifier = KEY_SHIFT;
			return 1;
		}
	}

	return 0;
}

unsigned char NonAlphaNumeric()
{
	int i = 0;
	unsigned char key;
	unsigned short num_xfer;
	unsigned char report_buffer[8];

	vos_memset(report_buffer, 0, 8);
	vos_dev_read(hSPI_SLAVE_1, &key, 1, &num_xfer);

	for (i = 0 ; i < NAN_KEY_COUNT; i++)
	{
		if (NonASCII[i][1] == key)
		{
			report_buffer[2] = NonASCII[i][0];
			vos_dev_write(hUSBSLAVEKEYBRD, report_buffer, 8, &num_xfer);
			report_buffer[2] = NonASCII[i][0] + 0x80;
			vos_dev_write(hUSBSLAVEKEYBRD, report_buffer, 8, &num_xfer);
		}
	}
	return 0;
}
